=== modified file 'client/drizzletest.cc'
--- client/drizzletest.cc	2011-06-16 18:54:30 +0000
+++ client/drizzletest.cc	2011-06-19 13:06:54 +0000
@@ -494,7 +494,7 @@
 
 void replace_append_mem(string& ds, const char *val, int len);
 void replace_append(string *ds, const char *val);
-void replace_append_uint(string *ds, uint32_t val);
+void replace_append_uint(string& ds, uint32_t val);
 void append_sorted(string& ds, const string& ds_input);
 
 void handle_error(st_command*,
@@ -818,49 +818,8 @@
   }
 }
 
-
-static void close_files()
-{
-  for (; cur_file >= file_stack.data(); cur_file--)
-  {
-    if (cur_file->file && cur_file->file != stdin)
-      fclose(cur_file->file);
-    free(const_cast<char*>(cur_file->file_name));
-    cur_file->file_name= 0;
-  }
-}
-
-static void free_used_memory()
-{
-  close_files();
-  BOOST_FOREACH(var_hash_t::reference i, var_hash)
-  {
-    free(i.second->str_val);
-    free(i.second->env_s);
-    if (i.second->alloced)
-      free(i.second);
-  }
-  var_hash.clear();
-  BOOST_FOREACH(st_command* i, q_lines)
-    delete i;
-  for (size_t i= 0; i < var_reg.size(); i++)
-  {
-    if (var_reg[i].alloced_len)
-      free(var_reg[i].str_val);
-  }
-  free_all_replace();
-  free(opt_pass);
-}
-
-
 static void cleanup_and_exit(int exit_code)
 {
-  if (0) // Olaf: Freeing resources is unnecessary when exiting
-  {
-    free_used_memory(); 
-    internal::my_end();
-  }
-
   if (!silent) 
   {
     switch (exit_code) 
@@ -1012,12 +971,10 @@
     ds_warning_messages.append("Warning detected ");
     if (cur_file && cur_file != file_stack.data())
     {
-      len= snprintf(buff, sizeof(buff), "in included file %s ",
-                    cur_file->file_name);
+      len= snprintf(buff, sizeof(buff), "in included file %s ", cur_file->file_name);
       ds_warning_messages.append(buff, len);
     }
-    len= snprintf(buff, sizeof(buff), "at line %d: ",
-                  start_lineno);
+    len= snprintf(buff, sizeof(buff), "at line %d: ", start_lineno);
     ds_warning_messages.append(buff, len);
   }
 
@@ -2896,11 +2853,8 @@
 */
 static void do_save_master_pos()
 {
-  drizzle::connection_c& con= *cur_con;
-  const char *query= "show master status";
-
   drizzle::result_c res;
-  dt_query(con, res, query);
+  dt_query(*cur_con, res, "show master status");
   drizzle_row_t row= res.row_next();
   if (!row)
     die("empty result in show master status");
@@ -3442,7 +3396,7 @@
     if (db)
       replace_append(&ds_res, db);
     ds_res.append(",");
-    replace_append_uint(&ds_res, port);
+    replace_append_uint(ds_res, port);
     ds_res.append(",");
     if (sock)
       replace_append(&ds_res, sock);
@@ -4364,41 +4318,38 @@
   Append metadata for fields to output
 */
 
-static void append_metadata(string *ds, drizzle::result_c& res)
+static void append_metadata(string& ds, drizzle::result_c& res)
 {
-  ds->append("Catalog\tDatabase\tTable\tTable_alias\tColumn\t"
-             "Column_alias\tType\tLength\tMax length\tIs_null\t"
-             "Flags\tDecimals\tCharsetnr\n");
-
+  ds += "Catalog\tDatabase\tTable\tTable_alias\tColumn\tColumn_alias\tType\tLength\tMax length\tIs_null\tFlags\tDecimals\tCharsetnr\n";
   res.column_seek(0);
   while (drizzle_column_st* column= res.column_next())
   {
-    ds->append(drizzle_column_catalog(column), strlen(drizzle_column_catalog(column)));
-    *ds += "\t";
-    ds->append(drizzle_column_db(column), strlen(drizzle_column_db(column)));
-    *ds += "\t";
-    ds->append(drizzle_column_orig_table(column), strlen(drizzle_column_orig_table(column)));
-    *ds += "\t";
-    ds->append(drizzle_column_table(column), strlen(drizzle_column_table(column)));
-    *ds += "\t";
-    ds->append(drizzle_column_orig_name(column), strlen(drizzle_column_orig_name(column)));
-    *ds += "\t";
-    ds->append(drizzle_column_name(column), strlen(drizzle_column_name(column)));
-    *ds += "\t";
+    ds += drizzle_column_catalog(column);
+    ds += "\t";
+    ds += drizzle_column_db(column);
+    ds += "\t";
+    ds += drizzle_column_orig_table(column);
+    ds += "\t";
+    ds += drizzle_column_table(column);
+    ds += "\t";
+    ds += drizzle_column_orig_name(column);
+    ds += "\t";
+    ds += drizzle_column_name(column);
+    ds += "\t";
     replace_append_uint(ds, drizzle_column_type_drizzle(column));
-    *ds += "\t";
+    ds += "\t";
     replace_append_uint(ds, drizzle_column_size(column));
-    *ds += "\t";
+    ds += "\t";
     replace_append_uint(ds, drizzle_column_type(column) == DRIZZLE_COLUMN_TYPE_TINY ? 1 : drizzle_column_max_size(column));
-    *ds += "\t";
-    ds->append((drizzle_column_flags(column) & DRIZZLE_COLUMN_FLAGS_NOT_NULL) ? "N" : "Y", 1);
-    *ds += "\t";
+    ds += "\t";
+    ds.append((drizzle_column_flags(column) & DRIZZLE_COLUMN_FLAGS_NOT_NULL) ? "N" : "Y", 1);
+    ds += "\t";
     replace_append_uint(ds, drizzle_column_flags(column));
-    *ds += "\t";
+    ds += "\t";
     replace_append_uint(ds, drizzle_column_decimals(column));
-    *ds += "\t";
+    ds += "\t";
     replace_append_uint(ds, drizzle_column_charset(column));
-    *ds += "\n";
+    ds += "\n";
   }
 }
 
@@ -4551,7 +4502,7 @@
       if (res.column_count())
       {
         if (display_metadata)
-          append_metadata(ds, res);
+          append_metadata(*ds, res);
 
         if (!display_result_vertically)
           append_table_headings(*ds, res);
@@ -6778,11 +6729,11 @@
 }
 
 /* Append uint32_t to ds, with optional replace */
-void replace_append_uint(string *ds, uint32_t val)
+void replace_append_uint(string& ds, uint32_t val)
 {
   ostringstream buff;
   buff << val;
-  replace_append_mem(*ds, buff.str().c_str(), buff.str().size());
+  replace_append_mem(ds, buff.str().c_str(), buff.str().size());
 
 }
 

=== modified file 'drizzled/dtoa.cc'
--- drizzled/dtoa.cc	2011-02-21 21:45:55 +0000
+++ drizzled/dtoa.cc	2011-06-16 20:59:51 +0000
@@ -622,12 +622,8 @@
 
 static Bigint *Balloc(int k)
 {
-  Bigint *rv;
-
-  /* TODO: some malloc failure checking */
-
   int x= 1 << k;
-  rv= (Bigint*) malloc(sizeof(Bigint));
+  Bigint* rv= (Bigint*) malloc(sizeof(Bigint));
 
   rv->p.x= (ULong*)malloc(x * sizeof(ULong));
 

=== modified file 'drizzled/filesort.cc'
--- drizzled/filesort.cc	2011-06-14 20:59:28 +0000
+++ drizzled/filesort.cc	2011-06-16 20:59:51 +0000
@@ -449,17 +449,14 @@
 static char **make_char_array(char **old_pos, uint32_t fields,
                               uint32_t length)
 {
-  char **pos;
-  char *char_pos;
-
-  if (old_pos ||
-      (old_pos= (char**) malloc((uint32_t) fields*(length+sizeof(char*))))) // todo: remove malloc check
-  {
-    pos=old_pos; char_pos=((char*) (pos+fields)) -length;
-    while (fields--) *(pos++) = (char_pos+= length);
-  }
-
-  return(old_pos);
+  if (not old_pos)
+    old_pos= (char**) malloc((uint32_t) fields * (length + sizeof(char*)));
+  char** pos= old_pos; 
+  char* char_pos= ((char*) (pos+fields)) - length;
+  while (fields--) 
+    *(pos++) = (char_pos+= length);
+
+  return old_pos;
 } /* make_char_array */
 
 

=== modified file 'drizzled/internal/mf_iocache.cc'
--- drizzled/internal/mf_iocache.cc	2011-06-14 20:42:14 +0000
+++ drizzled/internal/mf_iocache.cc	2011-06-16 20:59:51 +0000
@@ -237,36 +237,18 @@
   {
     /* Retry allocating memory in smaller blocks until we get one */
     cachesize= ((cachesize + min_cache-1) & ~(min_cache-1));
-    for (;;)
+    if (cachesize < min_cache)
+      cachesize = min_cache;
+    size_t buffer_block= cachesize;
+    if (type_arg == READ_CACHE && not global_read_buffer.add(buffer_block))
     {
-      size_t buffer_block;
-      if (cachesize < min_cache)
-	cachesize = min_cache;
-      buffer_block= cachesize;
-      if ((type_arg == READ_CACHE) and (not global_read_buffer.add(buffer_block)))
-      {
-        my_error(ER_OUT_OF_GLOBAL_READMEMORY, MYF(ME_ERROR+ME_WAITTANG));
-        return 2;
-      }
-
-      if ((buffer=
-	   (unsigned char*) malloc(buffer_block)) != 0) // todo: remove malloc check
-      {
-	write_buffer=buffer;
-	alloced_buffer= true;
-	break;					/* Enough memory found */
-      }
-      if (cachesize == min_cache)
-      {
-        if (type_arg == READ_CACHE)
-          global_read_buffer.sub(buffer_block);
-	return 2;				/* Can't alloc cache */
-      }
-      /* Try with less memory */
-      if (type_arg == READ_CACHE)
-        global_read_buffer.sub(buffer_block);
-      cachesize= (cachesize*3/4 & ~(min_cache-1));
+      my_error(ER_OUT_OF_GLOBAL_READMEMORY, MYF(ME_ERROR+ME_WAITTANG));
+      return 2;
     }
+
+    buffer= (unsigned char*) malloc(buffer_block);
+    write_buffer=buffer;
+    alloced_buffer= true;
   }
 
   read_length=buffer_length=cachesize;

=== modified file 'examples/simple.cc'
--- examples/simple.cc	2011-06-15 19:07:41 +0000
+++ examples/simple.cc	2011-06-19 09:36:23 +0000
@@ -34,13 +34,13 @@
  *
  */
 
-#include <cstdio>
-#include <cstdlib>
-#include <cstring>
-#include <getopt.h>
-#include <libdrizzle/drizzle_client.h>
-#include <netdb.h>
-#include <unistd.h>
+#include <cstdio>
+#include <cstdlib>
+#include <cstring>
+#include <getopt.h>
+#include <libdrizzle/drizzle_client.h>
+#include <netdb.h>
+#include <unistd.h>
 
 int main(int argc, char *argv[])
 {

=== modified file 'plugin/myisam/sort.cc'
--- plugin/myisam/sort.cc	2011-06-14 20:42:14 +0000
+++ plugin/myisam/sort.cc	2011-06-16 20:59:51 +0000
@@ -103,12 +103,9 @@
 int _create_index_by_sort(MI_SORT_PARAM *info,bool no_messages,
 			  size_t sortbuff_size)
 {
-  int error;
-  size_t maxbuffer, skr;
-  uint32_t memavl,old_memavl,keys,sort_length;
+  size_t skr;
+  uint32_t memavl,keys;
   DYNAMIC_ARRAY buffpek;
-  ha_rows records;
-  unsigned char **sort_keys;
   internal::io_cache_st tempfile, tempfile_for_exceptions;
 
   if (info->keyinfo->flag & HA_VAR_LENGTH_KEY)
@@ -127,12 +124,13 @@
   my_b_clear(&tempfile);
   my_b_clear(&tempfile_for_exceptions);
   memset(&buffpek, 0, sizeof(buffpek));
-  sort_keys= (unsigned char **) NULL; error= 1;
-  maxbuffer=1;
+  unsigned char** sort_keys= (unsigned char **) NULL; 
+  int error= 1;
+  size_t maxbuffer=1;
 
   memavl=max(sortbuff_size,(size_t)MIN_SORT_MEMORY);
-  records=	info->sort_info->max_records;
-  sort_length=	info->key_length;
+  ha_rows records= info->sort_info->max_records;
+  uint32_t sort_length= info->key_length;
 
   while (memavl >= MIN_SORT_MEMORY)
   {
@@ -143,25 +141,21 @@
     else
       do
       {
-	skr=maxbuffer;
-	if (memavl < sizeof(BUFFPEK)* maxbuffer ||
-	    (keys=(memavl-sizeof(BUFFPEK)* maxbuffer)/
-             (sort_length+sizeof(char*))) <= 1 ||
-            keys < maxbuffer)
-	{
-	  mi_check_print_error(info->sort_info->param,
-			       "myisam_sort_buffer_size is too small");
-	  goto err;
-	}
+        skr=maxbuffer;
+        if (memavl < sizeof(BUFFPEK)* maxbuffer ||
+          (keys=(memavl-sizeof(BUFFPEK)* maxbuffer) / (sort_length+sizeof(char*))) <= 1 ||
+          keys < maxbuffer)
+        {
+          mi_check_print_error(info->sort_info->param,
+            "myisam_sort_buffer_size is too small");
+          goto err;
+        }
       }
       while ((maxbuffer= (size_t)(records/(keys-1)+1)) != skr);
 
     sort_keys=(unsigned char **)malloc(keys*(sort_length+sizeof(char*)));
     my_init_dynamic_array(&buffpek, sizeof(BUFFPEK), maxbuffer, maxbuffer/2);
     break;
-    old_memavl=memavl; // todo: remove dead code
-    if ((memavl=memavl/4*3) < MIN_SORT_MEMORY && old_memavl > MIN_SORT_MEMORY)
-      memavl=MIN_SORT_MEMORY;
   }
   if (memavl < MIN_SORT_MEMORY)
   {

